#Hannah tutorial
#file:///Users/apple/Downloads/KLabWorkshop.html#/41
#http://www.phytools.org/eqg2015/asr.html
#https://lukejharmon.github.io/ilhabela/instruction/2015/06/02/ContinuousModels/
#Theory behind the tests
#https://bio.libretexts.org/Bookshelves/Evolutionary_Developmental_Biology/Book%3A_Phylogenetic_Comparative_Methods_(Harmon)/05%3A_Multivariate_Brownian_Motion/5.03%3A_Modeling_the_evolution_of_correlated_characters

#Plotting PGLS with visual scores. Manually transferred to pruned_char_data using the vlookup function in excel
#Does Ancestral state resconstruction on phylogenetic tree
#removed the nan / nr transcriptomes. Need to run on all
#install.packages("ape")
#install.packages("geiger")
#install.packages("DataCombine")
#install.packages("phytools")
library(ape)
library(phytools)
library(geiger)
#library(DataCombine)
#library(readxl)
#library(nlme)
library(picante)
setwd("~/Desktop/vis-trans/SMBE/Data_to_be_uploaded_to_Dryad/qc/rcode")
# example data 

lep_tree<-read.tree("pruned_tree.tre") # Read tree file with tip names
characterTable <- read.csv('pruned_char_data_test.csv', row.names = 1) #read data files with column 1 as row names and dropped na / nr valuse using excel
#characterTable <- read.csv('pruned_char_data.csv', row.names = 1) #read data files with column 1 as row names

#Filter by value
#characterTable=subset(characterTable,characterTable$busco_score >=0.20)


#Prunes trees and saves pruned tree in data
treeWData <- treedata(lep_tree, characterTable, sort = T);
lep_tree <-treeWData$phy

#Checks if the names in tree are the same as the names in the data table
name.check(lep_tree,characterTable)


#As a test case run vis_score and busco_score against each other
#plot(characterTable[, c("vis_score", "busco_score")])
characterTable$d

busco <- characterTable[,"busco_score"]

names(anoleSize) <- rownames(anoleData)

vis <- characterTable[, "vis_score"]

pglsModel <- gls(busco_score ~ vis_score, correlation = corBrownian(phy = lep_tree),
                 data = characterTable, method = "ML")
summary(pglsModel)
coef(pglsModel)
plot(busco ~ vis)
abline(a = coef(pglsModel)[1], b = coef(pglsModel)[2])

# Tests if diel habitat has a regression with busco_score 
pglsModel2 <- gls(busco_score ~ diel.habitat, correlation = corBrownian(phy = lep_tree),
                  data = characterTable, method = "ML")

anova(pglsModel2)

# Tests if diel habitat has a regression with % visual genes recovered
pglsModel3 <- gls(vis_score ~ diel.habitat, correlation = corBrownian(phy = lep_tree),
                  data = characterTable, method = "ML")

anova(pglsModel3)


pglsModel4 <- gls(number_opsins ~ vis_score, correlation = corBrownian(phy = lep_tree),
                  data = characterTable, method = "ML")
anova(pglsModel4)

pglsModel5 <- gls(number_opsins ~ busco_score, correlation = corBrownian(phy = lep_tree),
                  data = characterTable, method = "ML")
anova(pglsModel5)

print("Busco phylogenetic correlation Blombergs K. K<1 low signal, K>q signal and P-value <0.05 says there is signal")
names(busco) <- rownames(characterTable)
phylosignal(busco,lep_tree)
phylosig(lep_tree, busco, method = "K", test = T)

names(vis) <- rownames(characterTable)
phylosignal(vis,lep_tree)
phylosig(lep_tree, vis, method = "K", test = T)

#Filter if need to using subset commnf
#characterTable=subset(characterTable,characterTable$rh4_uv <=1)

#Prune tree and dataset using the tree data command
#plot(lep_tree)

#treeWData <- treedata(lep_tree, characterTable, sort = T); 

